#include <stdio.h>
#include <stdlib.h>
#include <mpi.h>

int main(int argc, char **argv){
    int number[20000], np, rank;
    MPI_Request *requests;
    int i;

    MPI_Init(&argc, &argv);
    MPI_Comm_size(MPI_COMM_WORLD, &np);
    if (np < 2){
        MPI_Abort(MPI_COMM_WORLD, 99);
    }
    MPI_Comm_rank(MPI_COMM_WORLD, &rank);

    if (rank == 0){
        printf("Type any number from the input: ");
        scanf("%d", &number[0]);

/*
        for (i=1; i<np; i++)
            MPI_Send(number, 1000, MPI_INT, i, 0, MPI_COMM_WORLD);
*/

        requests = (MPI_Request *)(malloc(sizeof(MPI_Request)*(np-1)));
        for (i=1; i<np; i++)
            MPI_Isend(number, 1000, MPI_INT, i, 0, MPI_COMM_WORLD, &requests[i-1]);

        MPI_Waitall(np-1, requests, MPI_STATUSES_IGNORE);
        free(requests);
    }else{
        MPI_Recv(number, 1000, MPI_INT, 0, 0, MPI_COMM_WORLD, MPI_STATUS_IGNORE);
        printf("My id is %d. I received %d\n", rank, number[0]);
    }  


    MPI_Finalize();
}
