// This program help user practice with basic blocking send and receive.
// Users need to fill in all the missing parameters in the send and receive 
// functions and understand how the message is transfered.
// Ignore the receiving status with MPI_STATUS_IGNORE

#include <stdio.h>
#include <mpi.h>

int main(int argc, char **argv){
    int number, np, rank;

    MPI_Init(&argc, &argv);
    MPI_Comm_size(MPI_COMM_WORLD, &np);

    // make sure np will be larger than 2 for the code to run correctly.
    if (np < 2){
        MPI_Abort(MPI_COMM_WORLD, 99);
    }

    MPI_Comm_rank(MPI_COMM_WORLD, &rank);
    if (rank == 0){

        printf("Type any number from the input: ");
        scanf("%d", &number);
        //process 0 sends to process 1
        MPI_Send();

    }else if (rank == np-1){
        // process np-1 receives from process np-2
        MPI_Recv(); 

    }else{
        // process i receive from process i-1
        MPI_Recv();
        // process i sends to process i+1
        MPI_Send();
        printf("My id is %d. I received %d\n", rank, number);
    }  

    MPI_Finalize();
}
