! this program help user practice with basic blocking send and receive.
! Users need to fill in all the missing parameters in the send and receive 
! functions and understand how the message is transfered.
! ignore the receiving status with MPI_STATUS_IGNORE

program ex2
use mpi
implicit none

integer rank, np, ierr, num

call MPI_INIT(ierr)

call MPI_COMM_SIZE(MPI_COMM_WORLD, np, ierr)
call MPI_COMM_RANK(MPI_COMM_WORLD, rank, ierr)

! make sure np is not smaller than 2
if (np < 2) then
    call MPI_ABORT(MPI_COMM_WORLD, 99, ierr)
endif

if (rank == 0) then

    print *, "Type an integer from the input"
    read *, num
    ! process 0 sends to process 1
    call MPI_SEND()

else if (rank == np-1) then

    ! process np-1 receives from process np-2
    call MPI_RECV()

else

    ! process i receives from i-1
    call MPI_RECV()
    ! process i sends to i+1
    call MPI_SEND()

    print "(2(A,I6))","Process ",rank, " received ", num
endif

call MPI_FINALIZE(ierr)

end program ex2
