#include <stdio.h>
#include <mpi.h>

int main(int argc, char **argv){
    int number, np, rank;
    MPI_Request requests[2];

    MPI_Init(&argc, &argv);
    MPI_Comm_size(MPI_COMM_WORLD, &np);
    if (np < 2){
        MPI_Abort(MPI_COMM_WORLD, 99);
    }
    MPI_Comm_rank(MPI_COMM_WORLD, &rank);

    number = rank;

    MPI_Irecv(&number, 1, MPI_INT, (rank-1+np)%np, (rank-1+np)%np, MPI_COMM_WORLD, &requests[0]);
    MPI_Isend(&number, 1, MPI_INT, (rank+1)%np, rank, MPI_COMM_WORLD, &requests[1]);

    MPI_Waitall(2, requests, MPI_STATUSES_IGNORE);

    printf("My id is %d. I received %d, sent by process %d\n", rank, number, (rank-1+np)%np);

    MPI_Finalize();
}
