/* calculate PI using 
    /1
    |   4.0
    | -------- dx = PI
    | (1+x*x)
    /0
*/

#include <stdio.h>
#include <omp.h>

#define N 100000000
#define MIN(x,y)   ((x)<(y)?(x):(y))

int main(int argc, char **argv){

    double h, x, sum, pi;
    int    i,j;
    double t1, t2;


    t1 = omp_get_wtime();

    h = 1.0/(double)N;
    sum = 0.0;

//#pragma omp parallel for private(i, x) reduction(+: sum)
    for (i=1; i<=N; i++){
       x = h*(i-0.5);
       sum += 4.0/(1.0+x*x); 
    }
    sum = sum*h;

    t2 = omp_get_wtime();

    printf("Pi is approx. %.20f\n", sum);
    printf("Total running time is %10.8f\n", t2-t1);

}
