#include <stdio.h>
#include <mpi.h>
#include <omp.h>

int main(int argc, char **argv){
    int buf, np, rank;
    int i;
    int provided;
    int tid, nth;

    MPI_Init_thread(&argc, &argv, MPI_THREAD_SINGLE, &provided);
    MPI_Comm_size(MPI_COMM_WORLD, &np);
    MPI_Comm_rank(MPI_COMM_WORLD, &rank);

#pragma omp parallel private(tid, nth, buf)
{
    tid = omp_get_thread_num();
    nth = omp_get_num_threads();

    if (rank == 0){
        MPI_Send(&tid, 1, MPI_INT, 1, tid, MPI_COMM_WORLD);
    }else{
        MPI_Recv(&buf, 1, MPI_INT, 0, tid, MPI_COMM_WORLD, MPI_STATUS_IGNORE);
        printf("My id is %d, and thread is %d. I received %d\n", rank, tid, buf);
    }  

}
    MPI_Finalize();
}
