#include <stdlib.h>
#include <stdio.h>
#include <mpi.h>
#include <omp.h>

int main(int argc, char **argv){
    int np, rank, tid, nth;
    int name_len;
    int provided;

    char proc_name[MPI_MAX_PROCESSOR_NAME];
//  MPI_Init(&argc, &argv);
//  MPI_Init_thread(&argc, &argv, MPI_THREAD_SINGLE, &provided);
//  MPI_Init_thread(&argc, &argv, MPI_THREAD_FUNNELED, &provided);
//  MPI_Init_thread(&argc, &argv, MPI_THREAD_SERIALIZED, &provided);
    MPI_Init_thread(&argc, &argv, MPI_THREAD_MULTIPLE, &provided);
    printf("MPI_THREAD_SINGLE = %d, provided=%d\n", MPI_THREAD_SINGLE, provided);
    MPI_Get_processor_name(proc_name, &name_len);

    MPI_Comm_size(MPI_COMM_WORLD, &np);
    MPI_Comm_rank(MPI_COMM_WORLD, &rank);

#pragma omp parallel private(tid, nth)
{
    tid = omp_get_thread_num();
    nth = omp_get_num_threads();
    printf("\"Hello, world\" from thread %d process %d on node %s, %d threads in each process and total %d processes.\n", tid, rank, proc_name, nth, np);
}
    MPI_Finalize();
}
