program hello
use mpi
implicit none
integer ierr, name_len, np, rank;
character (len=MPI_MAX_PROCESSOR_NAME) proc_name

integer tid, nth
integer omp_get_num_threads, omp_get_thread_num

call MPI_INIT(ierr)
call MPI_GET_PROCESSOR_NAME(proc_name, name_len, ierr)
call MPI_COMM_SIZE(MPI_COMM_WORLD, np, ierr)
call MPI_COMM_RANK(MPI_COMM_WORLD, rank, ierr)


!$OMP PARALLEL private(tid, nth)
tid = omp_get_thread_num()
nth = omp_get_num_threads()
print "(2(A, I3), 3(A), 2(I3, A))", "'Hello, world!' from thread", tid, " process ",rank, " on node ", trim(proc_name), &
      ", ", nth, " threads in each process and total ", np," processes."
!$OMP END PARALLEL


call MPI_Finalize(ierr)

end program hello
